#include <iostream>
#include <string.h>
#include <stdlib.h>
using namespace std;

/* 
Definire una funzione che prenda in input un array di stringhe.
La funzione restituisce un array di tipo bool dove ogni elemento indica se 
la stringa i-esima dello array di partenza e' palindroma.
Assumere come palindroma anche nel caso di caratteri Maiuscoli e Minuscoli
NB: Una stringa si dice palindroma se letta al contrario rimane invariata
Es: anna -> true; 
	lol -> true;
	Anna -> true
*/

bool function (char **S, int dim ){
	
	bool *out=new bool[dim];
	for(int i=0; i<dim ; i++){
		bool palindroma=true;
		int j=0, k=strlen(S[i])-1;
		while(palindroma && j<k)
		{
			if(tolower(S[i][j]) != tolower(S[i][k]))
				palindroma=false;
			j++;
			k--;
		}
		out[i]=palindroma;
		cout<<out[i]<<endl;	
	}
	return out;
}

int main(){
	char *a[3];
	
	
	a[0] = "anna";
	
	a[1] = "yamamay";
	
	a[2] = "stand";
	
	function (a, 3);
}
 
