#include<stdio.h>
#include<iostream>

using namespace std;
/* Scrivere un metodo che prenda in input una matrice quadrata A di short, 
   e restituisca un bool che indichi se la diagonale principale  identica 
   (procedendo dall'alto verso il basso) alla secondaria.*/

/*Variante dell'esercizio precedente in cui la matrice viene passata come
un doppio puntatore a short. Ci permette di operare su matrici quadrate di
dimensione n non fissa.*/


bool Identity(short** mat, int n) {
	//assumiamo che la condizione da soddisfare sia vera
	//fino a prova contraria
	bool diag = true;
	//mettiamo && diag nella condizione
	//per fermarci se la condizione non  pi verificata
	for(int i=0; i<n  && diag; i++) { //scorre le righe
		
		if(mat[i][i]!= mat[i][n-1-i]){
			
			diag = false;
		}
	}
	return diag;
}

int main() {
	//dato che devo passare le matrici come doppi puntatori,
	//devo definirle dinamicamente

	//una matrice 2D pu essere vista come un array di puntatori
	//da cui la notazione "new short*[]"
	
	short **mat1 = new short*[3];

	
	//ho creato due array di puntatori a short
	//adesso devo inizializzare ogni sotto-array (le righe della matrice)
	//facendo una nuova "new"
	for (int i=0; i<3; i++) {
		mat1[i] = new short[3];
	}

	//devo adesso inserire i valori nella matrice "manualmente"
	mat1[0][0] = 1; mat1[0][1] = 2; mat1[0][2] = 1;
	mat1[1][0] = 4; mat1[1][1] = 5; mat1[1][2] = 6;
	mat1[2][0] = 9; mat1[2][1] = 8; mat1[2][2] = 9;


	if(!Identity(mat1,3)) {
		cout<<"Le due diagonali non sono identiche"<<endl;
	} else {
		cout<<"Le due diagonali sono identiche"<<endl;
	}

}
